<template>
  <!-- Playlist -->
  <svn-pro-card class="w-full max-w-[376px] min-w-[260px] !border-0" v-if="cardType === 'playlist'">
    <div
      class="flex flex-col items-center h-[200px] relative"
      @click="emits('go-to-item-show')"
    >
      <div class="w-full h-full flex relative flex-1">
        <div class="flex gap-[10px] absolute right-2 top-2">
          <svn-pro-icon-button
            :icon="favoriteIcon"
            :class="isFavorited ? 'text-primary' : ''"
            color="surface"
            variant="elevated"
            @click.stop="onFavorite"
          />

          <svn-pro-icon-button
            v-if="shareable"
            :icon="shareableIcon"
            color="surface"
            @click.stop="onShare"
          />

          <slot v-if="editable" name="menu">
            <svn-pro-icon-button
              :icon="editableIcon"
              color="surface"
            />
          </slot>
        </div>

        <div v-if="playlistImages?.length" class="w-full h-[88px] flex items-start">
          <div
            v-for="(image, index) in playlistImages"
            :key="index"
            class="flex justify-center items-center bg-cover bg-center overflow-hidden h-full"
            :class="getWidth()"
            :style="{'background-image': `url('${image}')`}"
          />
        </div>

        <div v-else class="w-full h-[88px] bg-surfaceVariant pl-4 pb-4 flex items-end">
          <Icon
            icon="mingcute:folder-2-line"
            height="40"
            width="40"
            class="text-onSurfaceVariant opacity-[38%]"
          />
        </div>
      </div>

      <div class="w-full flex flex-col h-full justify-between items-start gap-2 px-4 pb-4 pt-3 bg-surfaceLight border-borderColor border-opacity-100 border border-t-0 rounded-bl-[12px] rounded-br-[12px]">
        <svn-pro-text subtitleLarge medium class="line-clamp-2">
          {{ cardTitle }}
        </svn-pro-text>

        <svn-pro-text bodyMedium medium color="onSurfaceVariant">
          {{ `${count} ${count > 1 ? 'modules' : 'module'}` }}
        </svn-pro-text>
      </div>
    </div>
  </svn-pro-card>

  <!-- Module -->
  <svn-pro-card class="w-full max-w-[376px] min-w-[260px] !border-0" v-if="cardType === 'module'">
    <div
      class="flex flex-col items-center  h-[328px] relative"
      @click="emits('go-to-item-show')"
    >
      <div class="w-full h-[112px] flex relative">
        <div class="flex gap-[10px] absolute right-2 top-2">
          <svn-pro-icon-button
            :icon="favoriteIcon"
            :class="isFavorited ? 'text-primary' : ''"
            color="surface"
            variant="elevated"
            @click.stop="onFavorite"
          />

          <svn-pro-icon-button
            v-if="shareable"
            :icon="shareableIcon"
            variant="elevated"
            color="surface"
            @click.stop="onShare"
          />

          <slot v-if="editable" name="menu">
            <svn-pro-icon-button
              :icon="editableIcon"
              variant="elevated"
              color="surface"
            />
          </slot>
        </div>

        <div
          v-if="cardImage"
          class="flex flex-col justify-center items-center w-full h-[112px] bg-cover bg-center"
          :style="{'background-image': `url('${cardImage}')`}"
        />

        <div v-else class="w-full h-[112px] bg-surfaceVariant pl-4 pb-4 flex items-end">
          <Icon
            icon="mingcute:folder-2-line"
            height="40"
            width="40"
            class="text-onSurfaceVariant"
          />
        </div>
      </div>

      <div class="h-full p-4 flex flex-col justify-between items-start self-stretch bg-surfaceLight border-borderColor border-opacity-100 border border-t-0 rounded-bl-[12px] rounded-br-[12px]">
        <div class="flex flex-col items-start gap-2">
          <svn-tags-cell :tags="themes" />

          <svn-pro-text subtitleLarge medium class="line-clamp-3">
            {{ cardTitle }}
          </svn-pro-text>

          <div class="flex items-center gap-1 self-stretch">
            <Icon
              icon="mingcute:time-line"
              height="16"
              width="16"
              class="text-onSurface"
            />

            <svn-pro-text bodyMedium regular color="onSurface">
              {{ duration }}
            </svn-pro-text>
          </div>
        </div>

        <div class="w-full flex justify-between items-center">
          <svn-pro-reaction-tag
            v-if="reactionCount"
            :reaction-list="reactionList"
            :reaction-count="reactionCount"
          />

          <v-spacer v-else></v-spacer>

          <svn-pro-info-tag
            v-if="isAcquired"
            :icon="acquiredIcon"
            :text="acquiredText"
            :leading-item="cardSize === 'default' ? 'icon' : undefined"
            tag-type="success"
            tag-style="filled"
          />
        </div>
      </div>
    </div>
  </svn-pro-card>

  <!-- Module in playlist/training -->
  <div
    v-if="cardType === 'module_in_playlist'"
    class="flex gap-3 items-center w-full relative rounded-[12px]"
    @click="emits('go-to-item-show')"
    :class="[cardSize === 'default' ?
      'max-w-[752px] border border-borderColor border-opacity-100' :
        `max-w-[540px] h-[120px]`]"
  >
    <svn-pro-card class="w-full !border-0" :link="!isDisabled">
      <div
        class="flex w-full rounded-[12px] bg-surfaceLight relative"
        :class="cardSize === 'default' ? 'p-4 gap-4 items-start' : 'items-center'"
      >
        <div :class="cardSize === 'default' ? 'w-[88px]' : 'w-[64px]'">
          <div
            class="flex justify-center items-center bg-cover bg-center overflow-hidden"
            :class="cardSize === 'default' ? 'rounded-[8px] w-[88px] h-[88px]' : ' w-[64px] h-[120px]'"
            :style="{'background-image': `url('${cardImage}')`}"
          />
        </div>

        <div
          class="w-full flex flex-col flex-1"
          :class="cardSize === 'default' ? 'gap-2 items-start' : 'h-[120px] gap-4 px-3 items-center justify-center rounded-br-[12px] rounded-tr-[12px] !border-l-0 border border-Color border-opacity-100'"
        >
          <div class="w-full flex py-0.5 items-start gap-1">
            <div class="w-full flex flex-col items-start gap-1">
              <div class="w-full flex items-center">
                <svn-pro-text subtitleLarge medium class="line-clamp-1 h-[28px] break-all">
                  {{ cardTitle }}
                </svn-pro-text>
              </div>

              <div class="flex items-center gap-1 self-stretch">
                <Icon
                  icon="mingcute:time-line"
                  height="16"
                  width="16"
                  class="text-onSurfaceVariant"
                />

                <svn-pro-text bodyMedium regular color="onSurfaceVariant">
                  {{ duration }}
                </svn-pro-text>
              </div>
            </div>

            <slot v-if="editable" name="menu">
              <svn-pro-menu
                :disabled="isDisabled"
              >
                <template #activator>
                  <svn-pro-icon-button
                    icon="custom:mingcute:more-2-line"
                    variant="text"
                    color="onSurfaceVariant"
                    :disabled="isDisabled"
                  />
                </template>

                <template #dropdown>
                  <v-list-item
                    value="edit_module"
                    :active="false"
                    @click="onClickEdit"
                  >
                    {{ editText }}
                  </v-list-item>

                  <v-list-item
                    value="delete_module"
                    :active="false"
                    @click="onClickDelete"
                    class="text-error"
                  >
                    {{ deleteText }}
                  </v-list-item>
                </template>
              </svn-pro-menu>
            </slot>
          </div>

          <div class="w-full flex justify-between gap-2 items-center">
            <svn-tags-cell v-if="themes?.length" :tags="themes" />

            <v-spacer v-else></v-spacer>

            <svn-pro-info-tag
              v-if="isAcquired"
              :icon="acquiredIcon"
              :text="acquiredText"
              :leading-item="cardSize === 'default' ? 'icon' : undefined"
              tag-type="success"
              tag-style="filled"
              :tag-size="cardSize === 'default' ? 'default' : 'compact'"
            />
          </div>
        </div>
      </div>
    </svn-pro-card>
  </div>

  <!-- Playlist in training edit -->
  <div
    v-if="cardType === 'playlist_in_training_edit'"
    @click="emits('go-to-item-show')"
    class="flex gap-3 items-center w-full relative"
    :class="cardSize === 'default' ? 'max-w-[752px]' : 'max-w-[540px] h-[120px]'"
  >
    <svn-pro-card
      class="w-full"
      :class="cardSize === 'default' ? '!rounded-[12px] border border-borderColor border-opacity-100' : '!rounded-[12px] !border-0'"
    >
      <div
        class="flex w-full bg-surfaceLight relative"
        :class="cardSize === 'default' ? 'p-4 gap-4 items-start' : 'items-center'"
      >
        <div
          v-if="playlistImages?.length"
          class="flex flex-col overflow-hidden"
          :class="cardSize === 'default' ? 'rounded-[8px] w-[88px] h-[88px]' : 'w-[64px] h-[120px]'"
        >
          <div
            v-for="(image, index) in playlistImages"
            :key="index"
            class="flex bg-cover bg-center overflow-hidden"
            :class="getHeight()"
            :style="{'background-image': `url('${image}')`}"
          />
        </div>

        <div v-else class="w-[88px] h-[88px] bg-surfaceVariant pl-4 pb-4 flex items-end rounded-[8px]">
          <Icon
            icon="mingcute:folder-2-line"
            height="40"
            width="40"
            class="text-onSurfaceVariant opacity-[38%]"
          />
        </div>

        <div
          class="w-full flex items-start"
          :class="cardSize === 'default' ? '' : 'h-[120px] rounded-br-[12px] rounded-tr-[12px] !border-l-0 border border-Color border-opacity-100'"
        >
          <div class="w-full h-full flex flex-col items-start flex-1" :class="cardSize === 'default' ? 'gap-2' : 'justify-center gap-4 px-3'">
            <div class="w-full flex items-start gap-1">
              <div class="w-full flex flex-col items-start gap-1 py-0.5">
                <div class="w-full h-full flex items-center justify-between">
                  <svn-pro-text subtitleLarge medium class="line-clamp-1 h-[28px] break-all">
                    {{ cardTitle }}
                  </svn-pro-text>
                </div>

                <svn-pro-text bodyMedium regular color="onSurfaceVariant">
                  {{ `${count} ${count > 1 ? 'modules' : 'module'}` }}
                </svn-pro-text>
              </div>
            </div>

            <svn-tags-cell v-if="themes?.length" :tags="themes" />
          </div>

          <slot v-if="editable" name="menu">
            <svn-pro-menu>
              <template #activator>
                <svn-pro-icon-button
                  icon="custom:mingcute:more-2-line"
                  variant="text"
                  color="onSurfaceVariant"
                />
              </template>

              <template #dropdown>
                <v-list-item
                  value="edit_module"
                  :active="false"
                  @click="onClickEdit"
                >
                  {{ editText }}
                </v-list-item>

                <v-list-item
                  value="delete_module"
                  :active="false"
                  @click="onClickDelete"
                  class="text-error"
                >
                  {{ deleteText }}
                </v-list-item>
              </template>
            </svn-pro-menu>
          </slot>
        </div>
      </div>
    </svn-pro-card>
  </div>

  <!-- Playlist in training show -->
  <div
    v-if="cardType === 'playlist_in_training_show'"
    class="w-full flex flex-col p-4 gap-2 items-start border border-borderColor border-opacity-100 rounded-2xl"
  >
    <div class="flex flex-col items-start gap-1 self-stretch">
      <div class="flex items-center gap-2">
        <div>
          <Icon
            icon="mingcute:play-line"
            height="24"
            width="24"
            class="text-onSurface"
          />
        </div>

        <svn-pro-text bodyLarge medium class="line-clamp-1 break-all">
          {{ cardTitle }}
        </svn-pro-text>
      </div>

      <svn-pro-text bodyMedium medium color="onSurfaceVariant">
        {{ `${count} ${count > 1 ? 'modules' : 'module'}` }}
      </svn-pro-text>
    </div>

    <svn-pro-card
      v-for="(playlistModule, index) in playlistModules"
      :key="index"
      class="w-full"
      :class="cardSize === 'default' ? '!rounded-[12px] border border-borderColor border-opacity-100' : '!rounded-[12px] !border-0'"
      @click="emits('go-to-item-show', playlistModule)"
    >
      <div
        class="flex w-full relative cursor-pointer bg-surfaceLight"
        :class="cardSize === 'default' ? 'p-4 gap-4 items-start' : 'items-center'"
      >
        <div
          class="flex justify-center items-center bg-cover bg-center overflow-hidden"
          :class="cardSize === 'default' ? 'rounded-[8px] w-[88px] h-[88px]' : ' w-[64px] h-[120px]'"
          :style="{'background-image': `url('${playlistModule?.cover_url?.['50']}')`}"
        />

        <div
          class="flex flex-col flex-1"
          :class="cardSize === 'default' ? 'gap-2 items-start' : 'gap-4 px-3 h-[120px] items-start justify-center rounded-br-[12px] rounded-tr-[12px] !border-l-0 border border-Color border-opacity-100'"
        >
          <div class="flex flex-col items-start gap-1">
            <svn-pro-text subtitleLarge medium class="line-clamp-1">
              {{ playlistModule?.title }}
            </svn-pro-text>

            <div class="flex items-center gap-1 self-stretch">
              <Icon
                icon="mingcute:time-line"
                height="16"
                width="16"
              />

              <svn-pro-text bodyMedium regular>
                {{ playlistModule?.duration }}
              </svn-pro-text>
            </div>
          </div>

          <div class="w-full flex justify-between gap-2 items-center">
            <svn-tags-cell v-if="playlistModule?.themes?.length" :tags="playlistModule?.themes?.map(theme => theme?.name)" />

            <v-spacer v-else></v-spacer>

            <svn-pro-info-tag
              v-if="playlistModule?.isAcquired"
              :icon="acquiredIcon"
              :text="acquiredText"
              :leading-item="cardSize === 'default' ? 'icon' : undefined"
              tag-type="success"
              tag-style="filled"
              :tag-size="cardSize === 'default' ? 'default' : 'compact'"
            />
          </div>
        </div>
      </div>
    </svn-pro-card>
  </div>
</template>

<script setup>
import { Icon } from '@iconify/vue';
import SvnProMenu from '../menu/SvnProMenu.vue';
import SvnTagsCell from '../table_cell/SvnTagsCell.vue';
import SvnProCard from "../../components/card/SvnProCard.vue";
import SvnProReactionTag from '../chip/SvnProReactionTag.vue';
import SvnProText from "../../components/styles/SvnProText.vue";
import SvnProInfoTag from "../../components/chip/SvnProInfoTag.vue";
import SvnProIconButton from "../../components/button/SvnProIconButton.vue";
import SvnProProgressLinear from "../../components/progress/SvnProProgressLinear.vue";
import SvnProButton from "../../components/button/SvnProButton.vue";

const props = defineProps({
  cardType: {
    type: String,
    default: "training",
  },
  cardSize: {
    type: String,
    default: "default",
  },
  cardImage: {
    type: String,
    default: undefined,
  },
  cardTitle: {
    type: String,
    default: undefined,
  },
  duration: {
    type: String,
    default: undefined,
  },
  remaining: {
    type: String,
    default: undefined,
  },
  count: {
    type: Number,
    default: undefined,
  },
  progress: {
    type: Number,
    default: undefined,
  },
  isFavorited: {
    type: Boolean,
    default: false,
  },
  editText: {
    type: String,
    default: 'Edit module',
  },
  deleteText: {
    type: String,
    default: 'Delete module',
  },
  favoriteIcon: {
    type: String,
    default: '$vuetify',
  },
  isAcquired: {
    type: Boolean,
    default: true,
  },
  editable: {
    type: Boolean,
    default: true,
  },
  editableIcon: {
    type: String,
    default: '$vuetify',
  },
  shareable: {
    type: Boolean,
    default: true,
  },
  isDisabled: {
    type: Boolean,
    default: false,
  },
  shareableIcon: {
    type: String,
    default: '$vuetify',
  },
  playlistImages: {
    type: Array,
    default: () => [],
  },
  themes: {
    type: Array,
    default: () => [],
  },
  acquiredText: {
    type: String,
    default: "Acquired",
  },
  acquiredIcon: {
    type: String,
    default: "mingcute:check-circle-fill",
  },
  reactionCount: {
    type: Number,
    default: undefined,
  },
  playlistModules: {
    type: Array,
    default: () => [],
  },
  reactionList: {
    type: Array,
    default: () => [],
  }
})

const emits = defineEmits(['on-favorite', 'on-share', 'on-edit', 'on-delete', 'go-to-item-show'])

const onFavorite = () => {
  emits('on-favorite')
}

const onShare = () => {
  emits('on-share')
}

const getWidth = () => {
  if (props?.playlistImages?.length === 1) {
    return "w-full"
  } else if (props?.playlistImages?.length === 2) {
    return "w-1/2"
  } else if (props?.playlistImages?.length === 3) {
    return "w-1/3"
  } else {
    return "w-1/4"
  }
}

const getHeight = () => {
  if (props?.playlistImages?.length === 1) {
    return "h-full"
  } else if (props?.playlistImages?.length === 2) {
    return "h-1/2"
  } else if (props?.playlistImages?.length === 3) {
    return "h-1/3"
  } else {
    return "h-1/4"
  }
}

const onClickEdit = () => {
  emits('on-edit')
}

const onClickDelete = () => {
  emits('on-delete')
}
</script>